Index: trunk/src/VBox/Frontends/VBoxManage/VBoxManageObjectTracker.cpp
===================================================================
--- trunk/src/VBox/Frontends/VBoxManage/VBoxManageObjectTracker.cpp	(revision 108565)
+++ trunk/src/VBox/Frontends/VBoxManage/VBoxManageObjectTracker.cpp	(revision 108566)
@@ -46,7 +46,4 @@
 std::map <com::Utf8Str, supIfaces_T> mapInterfaceNameToEnum = {
     {"IProgress", kProgress},
-    {"ISession", kSession},
-    {"IMedium", kMedium},
-    {"IMachine", kMachine}
 };
 
Index: trunk/src/VBox/Main/src-client/SessionImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-client/SessionImpl.cpp	(revision 108565)
+++ trunk/src/VBox/Main/src-client/SessionImpl.cpp	(revision 108566)
@@ -103,6 +103,4 @@
     mClientTokenHolder = NULL;
 
-    setTracked(18000, 60);//5 hours, 1 hour
-
     /* Confirm a successful initialization when it's the case */
     autoInitSpan.setSucceeded();
Index: trunk/src/VBox/Main/src-server/MachineImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 108565)
+++ trunk/src/VBox/Main/src-server/MachineImpl.cpp	(revision 108566)
@@ -304,5 +304,4 @@
 {
     LogFlowThisFunc(("\n"));
-    setTracked(0, 7200);//infinite, 2 hours
     return BaseFinalConstruct();
 }
Index: trunk/src/VBox/Main/src-server/MediumImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/MediumImpl.cpp	(revision 108565)
+++ trunk/src/VBox/Main/src-server/MediumImpl.cpp	(revision 108566)
@@ -986,6 +986,4 @@
     vrc = VDIfTcpNetInstDefaultCreate(&m->hTcpNetInst, &m->vdImageIfaces);
     AssertRCReturn(vrc, E_FAIL);
-
-    setTracked(0, 7200);//infinite, 2 hours
 
     return BaseFinalConstruct();
Index: trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp
===================================================================
--- trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 108565)
+++ trunk/src/VBox/Main/src-server/VirtualBoxImpl.cpp	(revision 108566)
@@ -6618,5 +6618,5 @@
         return setError(E_INVALIDARG, tr("The provided progress object GUID is invalid"));
 
-#if 0 /** @todo def VBOX_WITH_MAIN_OBJECT_TRACKER - never used */
+#ifdef VBOX_WITH_MAIN_OBJECT_TRACKER //0 /** @todo def VBOX_WITH_MAIN_OBJECT_TRACKER - never used */
     std::vector<com::Utf8Str> lObjIdMap;
     gTrackedObjectsCollector.getObjIdsByClassIID(IID_IProgress, lObjIdMap);
@@ -6636,5 +6636,5 @@
                 com::Bstr reqId(aId.toString());
                 Bstr foundId;
-                hrc = pProgress->COMGETTER(Id)(foundId.asOutParam());
+                pProgress->COMGETTER(Id)(foundId.asOutParam());
                 if (reqId == foundId)
                 {
@@ -6644,5 +6644,5 @@
                     BOOL aCanceled;
                     pProgress->COMGETTER(Canceled)(&aCanceled);
-                    LogRel(("Requested progress was found:\n  id %s\n  completed %s\n  canceled %s\n",
+                    Log2(("Requested progress was found:\n  id %s\n  completed %s\n  canceled %s\n",
                             aId.toString().c_str(),
                             aCompleted ? "True" : "False",
@@ -6672,4 +6672,16 @@
 }
 
+/**
+ * Get the tracked object by the Id.
+ *
+ * @param aTrObjId  tracked object Id
+ * @param aPIface  returns the ComPtr<IUnknown> if the object is found
+ * @param aState  returns TrackedObjectState_T - the actual state of the found
+ *                object
+ * @param aCreationTime  returns the creation time of the object
+ * @param aDeletionTime  returns the deletion time of the object
+ *
+ * @return HRESULT
+ */
 HRESULT VirtualBox::getTrackedObject(const com::Utf8Str &aTrObjId,
                                      ComPtr<IUnknown> &aPIface,
@@ -6692,5 +6704,7 @@
             *aDeletionTime = RTTimeSpecGetMilli(&time);
         }
-        /** @todo aDeletionTime isn't set */
+        else
+            /* aDeletionTime is set to 0 */
+            *aDeletionTime = 0;
     }
 
@@ -6707,7 +6721,4 @@
 static std::map<com::Utf8Str, com::Utf8Str> const g_lMapInterfaceNameToIID = {
     {"IProgress", Guid(IID_IProgress).toString()},
-    {"ISession", Guid(IID_ISession).toString()},
-    {"IMedium", Guid(IID_IMedium).toString()},
-    {"IMachine", Guid(IID_IMachine).toString()}
 };
 #endif